<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:import href="xslt-doc-utils.xsl" />

<xsl:key name="sources" match="source" use="@href" />

<xsl:template match="/">
   <html>
      <head>
         <title>Import Tree</title>
         <link rel="stylesheet" type="text/css" href="tree.css" />
      </head>
      <body>
         <div>
            <xsl:call-template name="insert-tree" />
         </div>
      </body>
   </html>
</xsl:template>

<xsl:template name="insert-tree">
   <xsl:param name="stylesheet" select="$source-stylesheet" />   
   <xsl:param name="base-URI" select="$source-stylesheet" />
   <xsl:variable name="filename">
      <xsl:call-template name="resolve">
         <xsl:with-param name="filename" select="$stylesheet" />
         <xsl:with-param name="base-URI" select="$base-URI" />
      </xsl:call-template>
   </xsl:variable>
   <span>
      <xsl:attribute name="onclick">
         <xsl:text>javascript:top.loadTree('</xsl:text>
         <xsl:call-template name="escape-js">
            <xsl:with-param name="string" select="$filename" />
         </xsl:call-template>
         <xsl:text>', '2')</xsl:text>
      </xsl:attribute>
      <xsl:text>-&#160;</xsl:text>
      <span>
         <xsl:attribute name="class">
            <xsl:value-of select="@type" />
            <xsl:if test="$filename = $current-stylesheet"> selected</xsl:if>
         </xsl:attribute>
         <xsl:value-of select="$filename" />
      </span>
   </span>
   <xsl:if test="position() != last()"><br /></xsl:if>
   <xsl:variable name="stylesheet-doc" select="document($stylesheet)/xsl:stylesheet" />
   <xsl:variable name="imports" select="$stylesheet-doc/xsl:import | $stylesheet-doc/xsl:include" />
   <xsl:if test="$imports">
      <div>
         <xsl:for-each select="$imports">
            <xsl:call-template name="insert-tree">
               <xsl:with-param name="stylesheet" select="@href" />
               <xsl:with-param name="base-URI" select="$filename" />
            </xsl:call-template>
         </xsl:for-each>
      </div>
   </xsl:if>
</xsl:template>

</xsl:stylesheet>