<?xml version="1.0"?>
<?xml-stylesheet type="text/xsl" href="xslt-doc.xsl" ?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:saxon="http://icl.com/saxon"
                xmlns:doc="http://www.jenitennison.com/xslt/doc"
                extension-element-prefixes="saxon">

<xsl:import href="xslt-doc-utils.xsl" />

<xsl:template match="xsl:stylesheet">
   <html>
      <head>
         <title>Stylesheet Documentation</title>
         <script type="text/javascript">
            function openStylesheet() {
               var undefined;
               var stylesheet = prompt('Enter the filename of the stylesheet, either relative to the XSLTDoc stylesheet or as a full URL:', '');
               if (stylesheet == undefined) {
                  alert('You must enter the name for the styleheet to be viewed.  Reload this page to try again.');
                  return;
               }
               sourceStylesheet = stylesheet;
               populateFrames();
            }
            
            var sourceStylesheet;
            var treeXSLTDOM;
            var summaryXSLTDOM;
            var summaryXSLT;
            var sourceXSLTDOM;
            var sourceXSLT;
            var notesXSLTDOM;
            var notesXSLT;

            function populateFrames() {
               treeXSLTDOM = getDOMFromFile("tree.xsl");
               summaryXSLTDOM = getDOMFromFile("summary.xsl");
               sourceXSLTDOM = getDOMFromFile("source.xsl");
               notesXSLTDOM = getDOMFromFile("notes.xsl");
               loadTree(sourceStylesheet, 2);
            }

            function loadTree(stylesheet, show) {
               var sourceDOM = getDOMFromFile(stylesheet);
               var treeXSLT = getProcessorFromDOMs(sourceDOM, treeXSLTDOM);
               treeXSLT.addParameter('source-stylesheet', sourceStylesheet);
               treeXSLT.addParameter('current-stylesheet', stylesheet);
               treeXSLT.addParameter('show', show);
               loadTransformedXML(treeXSLT, importFrame);
               summaryXSLT = getProcessorFromDOMs(sourceDOM, summaryXSLTDOM);
               sourceXSLT = getProcessorFromDOMs(sourceDOM, sourceXSLTDOM);
               notesXSLT = getProcessorFromDOMs(sourceDOM, notesXSLTDOM);
               loadSummary(stylesheet, show);
            }

            function loadSummary(stylesheet, show) {
               summaryXSLT.reset();
               summaryXSLT.addParameter('source-stylesheet', sourceStylesheet);
               summaryXSLT.addParameter('current-stylesheet', stylesheet);
               summaryXSLT.addParameter('show', show);
               loadTransformedXML(summaryXSLT, summaryFrame);
               loadSource(stylesheet, show);
            }

            function loadSource(stylesheet, show) {
               sourceXSLT.reset();
               sourceXSLT.addParameter('source-stylesheet', sourceStylesheet);
               sourceXSLT.addParameter('current-stylesheet', stylesheet);
               sourceXSLT.addParameter('show', show);
               loadTransformedXML(sourceXSLT, sourceFrame);
               loadNotes(stylesheet, show);
            }

            function loadNotes(stylesheet, show) {
               notesXSLT.reset();
               notesXSLT.addParameter('source-stylesheet', sourceStylesheet);
               notesXSLT.addParameter('current-stylesheet', stylesheet);
               notesXSLT.addParameter('show', show);
               loadTransformedXML(notesXSLT, notesFrame);
            }

            function highlight(stylesheet, show, node, row) {
               summaryFrame.select(row);
               sourceFrame.select(node);
               loadNotes(stylesheet, show);
            }
         </script>
         <script type="text/javascript" src="loadTransformedXML.js" />
      </head>
      <frameset rows="30%,*" onload="openStylesheet()">
         <frameset cols="30%,*">
            <frame name="importFrame" />
            <frame name="summaryFrame" />
         </frameset>
         <frameset cols="60%,*">
            <frame name="sourceFrame" />
            <frame name="notesFrame" />
         </frameset>
      </frameset>
   </html>
</xsl:template>

</xsl:stylesheet>